/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef ASYNCHRONOUS_SIGNALS_DEFAULT_COMBINER_HPP
#define ASYNCHRONOUS_SIGNALS_DEFAULT_COMBINER_HPP 1

#include <asynchronous/signals/optional_some_value.hpp>

namespace asynchronous
{

  namespace signals
  {

    template < typename Signature >
    class default_combiner;

    template < typename ... Args >
    class default_combiner< void(Args...) >
    {
      using self = default_combiner;

    public:
      void merge (self) {}
      void operator () () {}
      void result () const {}
    };

    template < typename Result, typename ... Args >
    struct default_combiner< Result(Args...) >
      : optional_some_value<Result(Args...)>
    {};

  } // namespace signals

} // namespace asynchronous

#endif
