/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef DATAFRAME_SKIP_HPP
#define DATAFRAME_SKIP_HPP 1

#include <dataframe/manipulator_storage_base.hpp>

namespace dataframe
{

  class skip_manipulator
    : public manipulator_storage_base< skip_manipulator,long >
  {
    using base = manipulator_storage_base< skip_manipulator,long >;
    
  public:
    template < typename ... Args >
    skip_manipulator (Args&& ... args)
      : base(std::forward<Args>(args)...)
    {}
  };

  skip_manipulator skip (long skip) { return skip_manipulator(skip); }
  skip_manipulator skip (std::ios_base& ios_base) { return skip_manipulator(ios_base); }
  
} // namespace dataframe

#endif
