/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef DATAFRAME_TRIM_FIELDS_HPP
#define DATAFRAME_TRIM_FIELDS_HPP 1

#include <dataframe/manipulator_storage_base.hpp>

namespace dataframe
{

  class trim_f
    : public manipulator_storage_base< trim_f >
  {
    using base = manipulator_storage_base< trim_f >;

  public:
    template < typename ... Args >
    trim_f (Args&& ... args)
      : base(std::forward<Args>(args)...)
    {};
  };

  auto trim_fields (std::ios_base& ios_base) { return trim_f(ios_base); }
  auto trim_fields (bool flag) { return trim_f(flag); }
  auto trim_fields () { return trim_fields(true); }
  
} // namespace dataframe

#endif
