/*
 * Copyright (c) 2017 Gregory Penn.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

#ifndef GDAL_OPENGDAL_READONLY_HPP
#define GDAL_OPENGDAL_READONLY_HPP

#include <gdal_priv.h>
#include <gdal/gdalregistration.hpp>

namespace gdal
{

  auto opengdal_readonly (const char* datasource)
  {
    gdalregistration::reg();
    return static_cast<GDALDataset*>
      (GDALOpenEx(datasource
		  , GDAL_OF_SHARED && GDAL_OF_READONLY
		  , NULL // consider all candidate drivers
		  , NULL // open options
		  , NULL // probe file system for sibling files
		  )
       );
  }

} // namespace gdal

#endif
