/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_CONCEPT_CDF_POLICY_CONCEPT_HPP
#define GRAPH_MODEL_CONCEPT_CDF_POLICY_CONCEPT_HPP 1

#include <boost/concept_check.hpp>
#include <graph_model/concept/probability_archetype.hpp>
#include <graph_model/concept/variate_archetype.hpp>

namespace graph_model
{

  namespace concept
  {

    template < typename T
	       , typename Variate = variate_archetype<>
	       , typename Probability = probability_archetype<>
	       >
    class cdf_policy_concept
    {
    public:
      BOOST_CONCEPT_USAGE(cdf_policy_concept)
      {
	cdf_ = t_.cdf();
	cdf_ = t_.cdf(variate_);
      }

    private:
      T const t_;
      Variate variate_;
      Probability cdf_;
    };

  } // namespace concept

} // namespace graph_model

#endif
