/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_CONCEPT_COMPATIBLE_RV_SAMPLER_CONCEPT_HPP
#define GRAPH_MODEL_CONCEPT_COMPATIBLE_RV_SAMPLER_CONCEPT_HPP 1

namespace graph_model
{

  namespace concept
  {

    template < typename RV, typename Expr >
    class compatible_rv_sampler_concept
    {
    public:
      BOOST_CONCEPT_USAGE(compatible_rv_sampler_concept)
      {
	rv_.reset_proposed_variate(expr_());
      }

    private:
      RV rv_;
      Expr expr_;      
    };

  } // namespace concept

} // namespace graph_model

#endif
