/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_CONCEPT_FUNCTION_CONCEPT_HPP
#define GRAPH_MODEL_CONCEPT_FUNCTION_CONCEPT_HPP 1

#include <boost/concept_check.hpp>
#include <boost/hana/traits.hpp>

namespace graph_model
{

  namespace concept
  {

    template < typename T >
    class function_concept
    {
    public:
      BOOST_CONCEPT_USAGE(function_concept)
      {
	auto is_function
	  = boost::hana::is_valid
	  ([](auto t) -> decltype((void)boost::hana::traits::declval(t)()){});
	static_assert(decltype(is_function(boost::hana::type_c<T>))::value,
		      "T must be a function class");
      }
    };

  } // namespace concept

} // namespace graph_model

#endif
