/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_VERTEX_SAMPLE_POLICY_ARCHETYPE_BASE_HPP
#define GRAPH_MODEL_VERTEX_SAMPLE_POLICY_ARCHETYPE_BASE_HPP 1

#include <graph_model/concept/something.hpp>
#include <graph_model/concept/type/variate_archetype_base.hpp>
#include <graph_model/concept/variate_archetype.hpp>

namespace graph_model
{

  namespace concept
  {

    /// Sample policy archetype base class
    ///
    template < typename Variate >
    struct sample_policy_archetype_base
    {
      template < typename ... Context >
      Variate sample (Context&& ... context) const { return something(); }
    };

  } // namespace concept

} // namespace graph_model

#endif
