/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_CONCEPT_SCALAR_FACTOR_ARCHETYPE_HPP
#define GRAPH_MODEL_CONCEPT_SCALAR_FACTOR_ARCHETYPE_HPP 1

#include <boost/concept_archetype.hpp>
#include <graph_model/concept/category_archetype.hpp>
#include <graph_model/concept/scalar_factor_archetype_base.hpp>
#include <graph_model/concept/identifier_archetype.hpp>
#include <graph_model/concept/probability_archetype.hpp>
#include <graph_model/concept/variate_archetype.hpp>
#include <graph_model/concept/vertex_category_archetype.hpp>

namespace graph_model
{

  namespace concept
  {

    template < typename Variate = variate_archetype<>
	       , typename Probability = probability_archetype<>
	       , typename Category = category_archetype<>
	       , typename Identifier = identifier_archetype<>
	       , typename VertexCategory = vertex_category_archetype<>
	       , typename Base = boost::null_archetype<>
	       >
    struct scalar_factor_archetype
      : scalar_factor_archetype_base<Variate,Probability,Category,Identifier,VertexCategory>
      , boost::default_constructible_archetype<Base>
    {};

  } // namespace concept

} // namespace graph_model

#endif
