/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_CONCEPT_SCALAR_FACTOR_ARCHETYPE_BASE_HPP
#define GRAPH_MODEL_CONCEPT_SCALAR_FACTOR_ARCHETYPE_BASE_HPP 1

#include <graph_model/concept/category_archetype.hpp>
#include <graph_model/concept/cdf_archetype_base.hpp>
#include <graph_model/concept/factor_archetype_base.hpp>
#include <graph_model/concept/identifier_archetype.hpp>
#include <graph_model/concept/probability_archetype.hpp>
#include <graph_model/concept/vertex_category_archetype.hpp>

namespace graph_model
{

  namespace concept
  {

    template < typename Variate
	       , typename Probability
	       , typename Category
	       , typename Identifier
	       , typename VertexCategory
	       >
    struct scalar_factor_archetype_base
      : factor_archetype_base<Probability,Category,Identifier,VertexCategory>
      , cdf_archetype_base<Variate,Probability>
    {};

  } // namespace concept

} // namespace graph_model

#endif
