/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_DISTRIBUTION_PARAMETER_ALPHA_HPP
#define GRAPH_MODEL_DISTRIBUTION_PARAMETER_ALPHA_HPP 1

#include <graph_model/distribution/parameter/named_parameter.hpp>

namespace graph_model
{

  namespace distribution
  {

    namespace parameter
    {
      
      namespace tag
      {

	struct alpha {};

      } // namespace tag

      namespace			// unnamed
      {

	struct alpha_type
	{
	  template < typename T >
	  auto operator = (T&& t)
	  {
	    return make_named_parameter<tag::alpha>(std::forward<T>(t));
	  }
	};

	alpha_type alpha;

      } // unnamed namespace

    } // namespace parameter

  } // namespace distribution

} // namespace graph_model

#endif
