/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_GRAPH_VERTEX_GID_PROPERTY_MAP_FWD_HPP
#define GRAPH_MODEL_GRAPH_VERTEX_GID_PROPERTY_MAP_FWD_HPP 1

#include <boost/property_map/property_map.hpp>
#include <graph_model/graph/tags.hpp>

namespace graph_model
{

  namespace graph
  {

    template < typename Graph >
    class vertex_gid_property_map;

  } // namespace graph

} // namespace graph_model

namespace boost
{

  template < typename Graph >
  struct property_map< Graph,::graph_model::graph::tag::vertex_gid >
  {
    using type = void;
    using const_type = graph_model::graph::vertex_gid_property_map<Graph>;
  };

} // namespace boost

#endif
