/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_SIGNALS_DEFAULT_SIGNAL_POLICY_HPP
#define GRAPH_MODEL_SIGNALS_DEFAULT_SIGNAL_POLICY_HPP 1

#include <boost/signals2/signal.hpp>

namespace graph_model
{

  namespace signals
  {

    class default_signal_policy
    {
      using connection_type = boost::signals2::connection;

    public:
      template < typename SignalTag, typename Slot >
      auto connect (Slot&&) { return connection_type(); }

      template < typename SignalTag, typename ... Args >
      void emit (Args&& ...) const {}
    };

  } // namespace signals

} // namespace graph_model

#endif
