/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_TRAITS_DIRECTED_CATEGORY_HPP
#define GRAPH_MODEL_TRAITS_DIRECTED_CATEGORY_HPP 1

#include <boost/graph/graph_traits.hpp>

namespace graph_model
{

  namespace traits
  {

    template < typename GraphTag >
    struct directed_category
    {
      using type = boost::directed_tag;
    };

    template < typename GraphTag >
    using directed_category_t = typename directed_category<GraphTag>::type;

  } // namespace traits

} // namespace graph_model

#endif
