/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_TYPE_SLOT_COLLECTION_HPP
#define GRAPH_MODEL_TYPE_SLOT_COLLECTION_HPP 1

#include <boost/poly_collection/function_collection.hpp>
#include <graph_model/type/slot_collection_fwd.hpp>
#include <use_default.hpp>

namespace graph_model
{

  namespace type
  {

    template < template < typename ... > class SlotCollection
	       , typename Signature
	       >
    struct default_slot_collection
    {
      using type = SlotCollection<Signature>;
    };

    template < typename Signature >
    struct default_slot_collection< use_default,Signature >
    {
      using type = boost::poly_collection::function_collection<Signature>;
    };

    template < template < typename ... > class SlotCollection, typename Signature >
    struct slot_collection
      : default_slot_collection<SlotCollection,Signature>
    {};

  } // namespace type

} // namespace graph_model

#endif
