/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_TYPE_TRAITS_IS_INCIDENCE_GRAPH_HPP
#define GRAPH_MODEL_TYPE_TRAITS_IS_INCIDENCE_GRAPH_HPP 1

#include <type_traits>
#include <graph_model/graph_tags.hpp>
#include <graph_model/traits/graph_tag.hpp>

namespace graph_model
{

  namespace type_traits
  {

    template < typename Graph >
    struct is_incidence_graph
      : std::is_base_of<tag::incidence_graph,traits::graph_tag_t<Graph>>
    {};

    template < typename Graph >
    using is_incidence_graph_t = typename is_incidence_graph<Graph>::type;

    template < typename Graph >
    constexpr auto is_incidence_graph_v = is_incidence_graph<Graph>::value;

  } // namespace type_traits

} // namespace graph_model

#endif
