/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_TYPE_TRAITS_IS_INTEGER_HPP
#define GRAPH_MODEL_TYPE_TRAITS_IS_INTEGER_HPP 1

#include <limits>
#include <type_traits>

namespace graph_model
{

  namespace type_traits
  {

    template < typename T >
    struct is_integer
    {
      using type = std::integral_constant<bool,std::numeric_limits<T>::is_integer>;
    };

    template < typename T >
    using is_integer_t = typename is_integer<T>::type;

    template < typename T >
    constexpr auto is_integer_v = is_integer<T>::value;

  } // namespace type_traits

} // namespace graph_model

#endif
