/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_UTILITY_TYPE_INVOCATION_POLICY_FWD_HPP
#define GRAPH_MODEL_UTILITY_TYPE_INVOCATION_POLICY_FWD_HPP 1

namespace graph_model
{

  namespace utility
  {

    namespace type
    {

      /// \brief Metafunction to select the invocation policy
      ///
      /// This class may be specialized to select different invocation
      /// policies based upon the argument.
      ///
      template < typename InvocationPolicy >
      class invocation_policy;

      template < typename InvocationPolicy >
      using invocation_policy_t = typename invocation_policy<InvocationPolicy>::type;

    } // namespace type

  } // namespace utility

} // namespace graph_model

#endif
