/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_VERTEX_FACTOR_IMPL_BASE_HPP
#define GRAPH_MODEL_VERTEX_FACTOR_IMPL_BASE_HPP 1

#include <graph_model/vertex/eval_pdf_base.hpp>
#include <graph_model/vertex/expression_impl_base.hpp>
#include <graph_model/vertex/markov_blanket_factor_base.hpp>
#include <graph_model/vertex/pdf_impl_base.hpp>

namespace graph_model
{

  namespace vertex
  {

    template < typename Derived, typename Category, typename Base >
    class factor_impl_base
      : public eval_pdf_base<Derived
      , pdf_impl_base<Derived
      , expression_impl_base<Derived,Category
      , Base
      > > >
      , public markov_blanket_factor_base<Derived>
      // , public expression_observer_collection_base<Derived,vertex<>>
    {};

  } // namespace vertex

} // namespace graph_model

#endif
