/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_VERTEX_SAMPLE_IMPL_BASE_HPP
#define GRAPH_MODEL_VERTEX_SAMPLE_IMPL_BASE_HPP 1

namespace graph_model
{

  namespace vertex
  {

    template < typename Derived, typename Base >
    class sample_impl_base
      : public Base
    {
      using base = Base;

    private:
      typename base::variate_type sample_ () const override { return strategy_().sample(); }

    private:
      auto& strategy_ () { return derived().strategy(); }
      auto& strategy_ () const { return derived().strategy(); }

    private:
      auto& derived () { return static_cast<Derived&>(*this); }
      auto& derived () const { return static_cast<Derived const&>(*this); }
    };

  } // namespace vertex

} // namespace graph_model

#endif
