/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_VERTEX_SUMMARIZED_SCALAR_RANDOM_VARIABLE_IMPL_BASE_HPP
#define GRAPH_MODEL_VERTEX_SUMMARIZED_SCALAR_RANDOM_VARIABLE_IMPL_BASE_HPP 1

#include <graph_model/vertex/scalar_random_variable_impl_base.hpp>
#include <graph_model/vertex/summarized_variate_impl_base.hpp>

namespace graph_model
{

  namespace vertex
  {

    template < typename Derived
	       , typename Category
	       , typename Variate
	       , typename Probability
	       , typename Stats
	       , typename Base
	       >
    struct summarized_scalar_random_variable_impl_base
      : summarized_variate_impl_base<Derived,Variate,Stats
      , scalar_random_variable_impl_base<Derived,Category,Variate
      , Base
      > >
    {};

  } // namespace vertex

} // namespace graph_model

#endif
