/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef LOGGING_CHANNEL_LOG_HPP
#define LOGGING_CHANNEL_LOG_HPP 1

#include <string>
#include <boost/log/sources/severity_channel_logger.hpp>
#include <boost/log/trivial.hpp>

namespace logging
{

  /// \brief Log class with channel
  ///
  class channel_log
    : public boost::log::sources::severity_channel_logger<boost::log::trivial::severity_level>
  {
    using base = boost::log::sources::severity_channel_logger<boost::log::trivial::severity_level>;

  public:
    channel_log () = default;
    channel_log (std::string channel)
      : base(boost::log::keywords::channel=channel)
    {}
    channel_log (char const* channel)
      : base(boost::log::keywords::channel=channel)
    {}
  };

} // namespace logging

#endif
