/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef SAMPLE_SPACE_VECTOR_MPL_BASIS_HPP
#define SAMPLE_SPACE_VECTOR_MPL_BASIS_HPP 1

#include <sample_space/vector/tag/euclidean_basis.hpp>
#include <sample_space/vector/tag/euclidean_vector_space.hpp>
#include <sample_space/vector/tag/simplex.hpp>
#include <use_default.hpp>

namespace sample_space
{

  namespace vector
  {

    namespace mpl
    {
    
      template < typename Tag, typename Basis >
      struct basis
      {
	using type = Basis;
      };

      template <>
      struct basis< tag::euclidean_vector_space,use_default<> >
      {
	using type = sample_space::vector::tag::euclidean_basis;
      };

      template <>
      struct basis< tag::simplex,use_default<> >
      {
	using type = sample_space::vector::tag::euclidean_basis;
      };

      template < typename Tag, typename Basis >
      using basis_t = typename basis<Tag,Basis>::type;

    } // namespace mpl

  } // namespace vector
  
} // namespace sample_space

#endif
