/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef SAMPLE_SPACE_VECTOR_MPL_VECTOR_STORAGE_HPP
#define SAMPLE_SPACE_VECTOR_MPL_VECTOR_STORAGE_HPP 1

#include <sample_space/vector/tag/array.hpp>
#include <sample_space/vector/tag/vector.hpp>
#include <sample_space/vector/policy/array_storage_policy.hpp>
#include <sample_space/vector/policy/vector_storage_policy.hpp>
#include <use_default.hpp>

namespace sample_space
{

  namespace vector
  {

    namespace mpl
    {
    
      template < typename T
		 , typename Index
		 , typename Storage
		 >
      class vector_storage;

      template < typename T, std::size_t Size >
      struct vector_storage<T,void,tag::array<Size>>
      {
	using type = policy::array_storage_policy<T,Size>;
      };

      template < typename T, typename Index >
      struct vector_storage<T,Index,tag::vector>
      {
	using type = policy::vector_storage_policy<T,Index>;
      };

      template < typename T, typename Index >
      struct vector_storage<T,Index,use_default<>>
	: vector_storage<T,Index,tag::vector>
      {};

      template < typename T
		 , typename Index
		 , typename Storage
		 >
      using vector_storage_t = typename vector_storage<T,Index,Storage>::type;
    
    } // namespace mpl

  } // namespace vector
  
} // namespace sample_space

#endif
