/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef SAMPLE_SPACE_VECTOR_TYPE_TRAITS_IS_MAP_HPP
#define SAMPLE_SPACE_VECTOR_TYPE_TRAITS_IS_MAP_HPP 1

#include <type_traits>
#include <boost/mpl/and.hpp>
#include <boost/mpl/not.hpp>
#include "sample_space/vector/tag/vector.hpp"
#include "use_default.hpp"

namespace sample_space
{

  namespace vector
  {
  
    namespace type_traits
    {

      template < typename Index, typename Storage >
      struct is_map
	: std::integral_constant< bool
				  , boost::mpl::and_< boost::mpl::not_<std::is_void<Index>>
						      , std::is_same<Storage,tag::vector>
						      >::value
				  >
      {};

      template < typename Index, typename Storage >
      using is_map_t = typename is_map<Index,Storage>::type;
    
    } // namespace type_traits

  } // namespace vector
  
} // namespace sample_space

#endif
