/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef SIGNALS_TAGS_HPP
#define SIGNALS_TAGS_HPP 1

#include <iosfwd>

namespace signals
{

  namespace tag
  {

#define DEFINE_SIGNAL_TAG(Tag)			      \
    class Tag {};				      \
    std::ostream& operator << (std::ostream& os, Tag) \
    { return os << "signals::tag::" << #Tag; }	      \
    /**/

    DEFINE_SIGNAL_TAG(variate);
    DEFINE_SIGNAL_TAG(accept);
    DEFINE_SIGNAL_TAG(reject);
    DEFINE_SIGNAL_TAG(internal_mcmc_state);

#undef DEFINE_SIGNAL_TAG
    
  } // namespace tag
  
} // namespace signals

#endif
