/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU General Public
 *     License as published by the Free Software Foundation, either
 *     version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public
 *     License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef TRAITS_VALUE_HPP
#define TRAITS_VALUE_HPP 1

namespace traits
{

  namespace defaults
  {

    template < typename T >
    struct value
    {
      using type = T;
    };

  } // namespace defaults

  template < typename T >
  struct value
    : defaults::value<T>
  {};

  template < typename T >
  struct value< T const >
    : value<T>
  {};

  template < typename T >
  struct value< T& >
    : value<T>
  {};

  template < typename T >
  struct value< T const& >
    : value<T>
  {};

  template < typename T >
  struct value< T&& >
    : value<T>
  {};

  template < typename T >
  struct value< T const&& >
    : value<T>
  {};

  template < typename T >
  using value_t = typename value<T>::type;
  
} // namespace traits

#endif
