#
# Copyright (c) 2017 Brook Milligan.
#
# This file is part of the GraphModel Library.
#
#     The GraphModel Library is free software: you can redistribute it
#     and/or modify it under the terms of the GNU General Public
#     License as published by the Free Software Foundation, either
#     version 3 of the License, or (at your option) any later version.
#
#     The GraphModel Library is distributed in the hope that it will
#     be useful, but WITHOUT ANY WARRANTY; without even the implied
#     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#     See the GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public
#     License along with the GraphModel Library.  If not, see
#     <http://www.gnu.org/licenses/>.
#

library(ggplot2)

label <- expression(p)

filename <- 'mcmc.dat'
pdfname <- 'mcmc.pdf'

samples.filename <- 'samples.dat'

data <- read.delim(filename)

samples <- read.delim(samples.filename)

pdf(pdfname,width=7,height=5)
ggplot(data,aes(x=MCMC_sample)) +
  theme_bw() +
  labs(x=label,y='Count') +
  geom_histogram(color='gray',fill='gray') +
  geom_vline(aes(xintercept=mean(samples$samples)),linetype='dashed') +
  geom_vline(aes(xintercept=mean(MCMC_sample)))
ggplot(data,aes(x=i,y=MCMC_sample)) +
  theme_bw() +
  labs(x='MCMC iteration',y=label) +
  geom_step(color='gray') +
  geom_hline(aes(yintercept=mean(samples$samples)),linetype='dashed') +
  geom_hline(aes(yintercept=mean(MCMC_sample)))
dev.off()
